class RokData
  def initialize
    @points = Array.new
    @lines = Array.new
    @faces = Array.new
    @pallet = Array.new
  end
  def gets
    l = @file.gets("\r")
    #p l
    return l
  end
  def load(filename)
    @file = open(filename, "rb")
    p @file
    if @file
      line = gets
      while true
        if line == nil
          break
        end
        line.chomp!
        #print line, "\n"
        case line
        when "ROKU4"
          p line
          14.times { gets }
          line = gets
        when "POINT"
          #p line
          while (line = gets) && (line.to_i != 0)
            scale = 1
            p =  Point.new(line.to_i, gets.to_i, gets.to_i,
                           gets.to_i, gets.to_i,
                           gets.to_f / scale, gets.to_f / scale, gets.to_f / scale)
            @points[p.num] = p
          end
          p line
          p "END POINT"
        when "LINE0"
          p line
          while (line = gets) && (line.to_i != 0)
            np1 = line.to_i
            np2 = gets.to_i
            @lines.push Line.new(@points[np1], @points[np2], gets.to_i, gets.to_i == 0)
          end
          p line
          p "END LINE0"
        when "FACE0"
          p line
          while (line = gets) && (line.chomp != "END00")
            nface = line.to_i
            color = gets.to_i
            num = gets.to_i
            lines = Array.new
            #print "FACE n=", nface
            if nface > 4 then
              print "non supported FACE ", nface
              break
            end
            valid = true
            nface.times {
              n = gets.to_i - 1
              if @lines[n] == nil
                valid = false
              end
              lines.push @lines[n]
            }
            if valid
              @faces[num] = Face.new(num, color, lines)
              #p num
            end
          end
          p line
          p "END FACE0"
        when "PALC0"
          p line
          while (line = gets) && (line.chomp != "ENDP0")
            p line
            ncol = line.to_i
            sellected = gets.to_i
            ncol.times {
              r1 = gets.to_i / 256.0
              g1 = gets.to_i / 256.0
              b1 = gets.to_i / 256.0
              r2 = gets.to_i / 256.0
              g2 = gets.to_i / 256.0
              b2 = gets.to_i / 256.0
              dummy = gets.to_i
              pl = Pallet.new([r1, g1, b1], [r2, g2, b2])
              @pallet.push pl
              p "pallet ", @pallet.size, pl.color1, pl.color2, "\n"
            }
          end
          p line
          line = gets
          p "END PALC0"
        else
          line = gets
        end
      end
    end
  end
  def points
    return @points
  end
  def lines
    return @lines
  end
  def faces
    return @faces
  end
  def pallet
    return @pallet
  end
end

class Point
  def initialize(num, group, visible, dummy, point, x, y, z)
    @num = num
    @group = group
    @visible = visible
    @dummy = dummy
    @point = point
    @pos = [x, y, z]
    #print "P ",num,"(", x,",", y, ",", z, ")\n"
  end
  def num
    return @num
  end
  def pos
    return @pos
  end
end

class Line
  def initialize(p1, p2, group, visible)
    @p1 = p1
    @p2 = p2
    @group = group
    @visible = visible
    #print "L ","(", p1,",", p2, ")\n"
  end
  def visible?
    return @visible
  end
  def p1
    return @p1
  end
  def p2
    return @p2
  end
end

class Face
  def initialize(num, color, lines)
    @num = num
    @color = color
    @lines = lines
    @points = nil
    @norm = nil
    collect_points
  end
  def num
    return @num
  end
  def lines
    return @lines
  end
  def points
    return @points
  end
  def color 
    return @color
  end
  def norm
    if @norm == nil
      v1 = [@points[1].pos[0] - @points[0].pos[0],
        @points[1].pos[1] - @points[0].pos[1],
        @points[1].pos[2] - @points[0].pos[2]]
      v2 = [@points[2].pos[0] - @points[0].pos[0],
        @points[2].pos[1] - @points[0].pos[1],
        @points[2].pos[2] - @points[0].pos[2]]
      @norm = [v1[2]*v2[1] - v1[1]*v2[2],
        v1[0]*v2[2] - v1[2]*v2[0],
        v1[1]*v2[0] - v1[0]*v2[1]]
    end
    return @norm
  end
  def collect_points
    @points = Array.new
    for j in 0..(lines.size-1) do
      if @lines[j] == nil
        return
      end
    end
    for j in 0..(lines.size-1) do
      #print j, "/", lines.size - 1, "\n"
      line = @lines[j]
#      if line == nil
#        next
#      end
      p1 = line.p1
      p2 = line.p2
      n = j + 1
      n %= lines.size
      next_line = @lines[n];
#      if next_line == nil
#        next
#      end
      p3 = next_line.p1
      p4 = next_line.p2
      #print p1, p2, p3, p4
      if( p1 == p3 || p1 == p4 )
        @points[j] = p2
      else
        @points[j] = p1
      end
    end
  end
end

class Pallet
  def initialize(color1, color2)
    @color1 = color1
    @color2 = color2
  end
  def color1
    return @color1
  end
  def color2
    return @color2
  end
end
