#!/drv/c/usr/local/bin/ruby -w
require 'sdl'
require 'opengl'

require 'rokload'

SDL.init SDL::INIT_VIDEO
SDL.setGLAttr SDL::GL_RED_SIZE,5
SDL.setGLAttr SDL::GL_GREEN_SIZE,5
SDL.setGLAttr SDL::GL_BLUE_SIZE,5
SDL.setGLAttr SDL::GL_DEPTH_SIZE,16
SDL.setGLAttr SDL::GL_DOUBLEBUFFER,1
SDL.setVideoMode 640,400,16,SDL::OPENGL
GL::Viewport( 0, 0, 640, 400 );
GL::MatrixMode( GL::PROJECTION );
GL::LoadIdentity( );

GL::MatrixMode( GL::MODELVIEW );
GL::LoadIdentity( );

GL::Enable(GL::DEPTH_TEST);

GL::DepthFunc(GL::LESS);

GL::ShadeModel(GL::SMOOTH);

GL::Disable(GL::CULL_FACE)
GL::LightModel(GL::LIGHT_MODEL_TWO_SIDE, GL::FALSE);
GL::Enable(GL::LIGHTING)
GL::Light(GL::LIGHT0, GL::POSITION, [2000, 2000, 0])
#GL::Light(GL::LIGHT0, GL::DIFFUSE, [255, 255, 255, 255])
GL::Light(GL::LIGHT0, GL::DIFFUSE, [255, 255, 255, 255])

GL::Light(GL::LIGHT1, GL::POSITION, [0, 0, 1000])
#GL::Light(GL::LIGHT0, GL::DIFFUSE, [255, 255, 255, 255])
GL::Light(GL::LIGHT1, GL::DIFFUSE, [255, 255, 255, 255])

GL::LightModel(GL::LIGHT_MODEL_AMBIENT, [1, 1, 1, 1])
GL::Enable(GL::LIGHT0)
GL::Enable(GL::LIGHT1)

event=SDL::Event.new
shadedCube=true

color =
  [[ 1.0,  1.0,  0.0], 
  [ 1.0,  0.0,  0.0],
  [ 0.0,  0.0,  0.0],
  [ 0.0,  1.0,  0.0],
  [ 0.0,  1.0,  1.0],
  [ 1.0,  1.0,  1.0],
  [ 1.0,  0.0,  1.0],
  [ 0.0,  0.0,  1.0]]

cube =
  [[ 0.5,  0.5, -0.5], 
  [ 0.5, -0.5, -0.5],
  [-0.5, -0.5, -0.5],
  [-0.5,  0.5, -0.5],
  [-0.5,  0.5,  0.5],
  [ 0.5,  0.5,  0.5],
  [ 0.5, -0.5,  0.5],
  [-0.5, -0.5,  0.5]]


filename = ARGV.shift
r = RokData.new
r.load filename
r.points().each do |p|
#  puts p
end

loop do
  if  event.poll != 0 then
    if event.type==SDL::Event::QUIT then
      break
    end
    if event.type==SDL::Event::KEYDOWN then
      exit
    end
  end

  GL.ClearColor(0.0, 0.0, 0.0, 1.0);
  GL.Clear(GL::COLOR_BUFFER_BIT|GL::DEPTH_BUFFER_BIT);


#  GL::Begin(GL::QUADS)

  if shadedCube then
    #GL::Begin(GL::LINES) 
    GL::Begin(GL::QUADS)
    r.faces.each do |f|
      if f == nil || f.points == nil
        next
      end
      if f.points.size == 4
        if f.color != nil && r.pallet[f.color] != nil
          c = r.pallet[f.color].color1
          if c != nil
            #GL::Material(GL::FRONT, GL::SPECULAR, c);#[1.0, 1.0, 1.0, 1.0]);
          end
          c = r.pallet[f.color].color2
          if c != nil
            GL::Material(GL::FRONT, GL::DIFFUSE, c);
          end
        end
        norm = f.norm
        if norm != nil
          GL::Normal(norm)
        end
        #f.points.each do |l|
        for i in 0..3
          p1 = f.points[i]
          #p2 = f.points[(i+1)%4]
          GL::Vertex(p1.pos);
          #GL::Vertex(p2.pos);
        end
        if norm != nil
          GL::Normal([-norm[0], -norm[1], -norm[2]])
        end
        #f.points.each do |l|
        for i in 3..0
          p1 = f.points[i]
          #p2 = f.points[(i+1)%4]
          GL::Vertex(p1.pos);
          #GL::Vertex(p2.pos);
        end
      end
      #  puts p
    end
    GL::End()
    GL::Begin(GL::TRIANGLES)
    r.faces.each do |f|
      if f == nil || f.points == nil
        next
      end
      if f.lines.size == 3
        if f.color != nil && r.pallet[f.color] != nil
          c = r.pallet[f.color].color2
          if c != nil
            GL::Material(GL::FRONT, GL::DIFFUSE, c);
          end
        end
        norm = f.norm
        if norm != nil
          GL::Normal(norm)
        end
        for i in 0..2
          p1 = f.points[i]
          GL::Vertex(p1.pos);
        end
        if norm != nil
          GL::Normal([-norm[0], -norm[1], -norm[2]])
        end
        for i in 2..0
          p1 = f.points[i]
          GL::Vertex(p1.pos);
        end
      end
    end
    GL::End()
  end
  
  GL::MatrixMode(GL::MODELVIEW);
  GL::Rotate(5.0, 1.0, 1.0, 1.0);
  
  SDL.GLSwapBuffers

end
